
use strict;
use CFITSIO qw( :longnames :constants);

use PDL;
use PGPLOT;
use  PDL::Graphics::PGPLOT;
use Common::fitsio;
use Tie::IxHash;

use Mylib::Prered;
use Mylib::Robust;
use Mylib::Pfit;


&imtest;

sub imtest {

my $nim1="/i4/radovich/link/Processed/Store/Fringe.WFI.Iclw.2000-01-13.#05.fits";
my $nim2="/i4/radovich/link/Processed/Temp/wfi5_0032.WFI.Iclw.sfrg.#05.fits";
#my $nim1="/i4/radovich/link/Processed/Store/Fringe.WFI.Iclw.#03.fits";
#my $nim2="/i4/radovich/link/Processed/Temp/wfi5_0032.WFI.Iclw.OTBYW.#05.fits";

#my $nim1="/home/mario/Perl/PipeV0.9/sfringe.fits";
#my $nim2="/home/mario/Perl/PipeV0.9/simage.fits";

my (%fh1, %fh2);
tie (%fh1, 'Tie::IxHash'); 
tie (%fh2, 'Tie::IxHash'); 

%fh1=&fitsio::rhead($nim1);
%fh2=&fitsio::rhead($nim2);

die "No $nim1" if (! -e $nim1);
die "No $nim2" if (! -e $nim2);

my ($im1, $ret)=&fitsio::rfits($nim1);
my ($im2, $ret)=&fitsio::rfits($nim2);

my $x=$im1->clump(-1);
my $y=$im2->clump(-1);

#my $scale=1.035;
#$y-=($x*$scale);

##my $cc=float[2606.10004272224, 1.06975891553907, 0.000387607764096766 ];
##my $yfit=polyeval($x, $cc);
##$y-=$yfit;

my @cc;


##&fitsio::wfits($im2, "prova.fits", \%fh2);

#die;

#------------


warn "computing average";
my $sigma=2;

# my ($avim, $sim) = avsigclip($y, $sigma, 3, -1000);
# warn "computing robust sigma";
# my $rsig=&Mylib::Robust::Robust_Sigma($y);

#warn "1. $avim, $sim, $rsig";


warn "smoothing....";


my $xs=&Mylib::Robust::MedBlock($x, 10);
my $ys=&Mylib::Robust::MedBlock($y, 10);

#my @cc=Robust_PolyFit($x, $y, 3);
#my $yf=float(polyeval($x, float(@cc)));

warn "starting computation !\n";



#my $yf=zeroes(float, $y->nelem);
my @ss=();
my $sig;

my @cc=&Mylib::Robust::Robust_LinFit($xs, $ys, \$sig, \@ss);


#my @cc=&Mylib::Robust::Robust_PolyFit($xs, $ys, 3);


#print $yf;
print "\n @cc \n $sig\n @ss\n";
print "--> ", $sig/$cc[0]*100,"\n";
print "--> ", $ss[0]/$cc[0]*100,"  ",  $ss[1]/$cc[1]*100, "\n";

 

#warn "plotting....";

$xs=&Mylib::Robust::MedBlock($x, 10);
$ys=&Mylib::Robust::MedBlock($y, 10);




my $plot = PDL::Graphics::PGPLOT::Window->new({Device=>"plot.ps/CPS", CharSize=>1.2       });

my $opt= {COLOR=>'BLACK', SYMBOL=>'DOT'};

my ($xmin, $xmax, $ymin, $ymax)=&Mylib::Robust::RPlot($plot, $xs, $ys, $opt);

my $xl=float[$xmin, $xmax];
my $yl=$cc[0]+$cc[1]*$xl;
$plot->line ($xl, $yl, {COLOR=>'RED'});


##my $yf=float(polyeval($xs, float(@cc)));
##$plot->line ($xs, $yf, {COLOR=>'RED'});

$plot->close;

## subtract the fringe and write the image

#$im1*=$cc[1];
#$im2-=$im1;

# my ($avim, $sim) = avsigclip($y, $sigma, 3, -1000);
#$rsig=&Mylib::Robust::Robust_Sigma($y);

#warn "2. $avim, $sim, $rsig";

#my $nim1=$cc[1]*$im1+$cc[2]*($im1**2);
#$im2-=$nim1;

#&fitsio::wfits($im2, "prova.fits", \%fh2);

warn "done !\n";


}


sub rtest
  {
my $x=float[1..1000];
my $y=(10+3*$x)+random(float,1000);
my $sig=1;

my $ty=$y->slice("500:600");
$ty*=random(float,101);

 $ty=$y->slice("200:250");
$ty/=random(float,51);

#set $y,5, $y->at(5)*10;
#set $y,0, $y->at(0)/10;
#print "$y";

my $yf=zeroes(float, $y->nelem);
my @ss=();
my @cc=Mylib::Robust::Robust_LinFit($x, $y, \$sig, \@ss, $yf);

#print $yf;
print "\n @cc \n $sig\n @ss";


my $plot = PDL::Graphics::PGPLOT::Window->new({Device=>"plot.ps/CPS", CharSize=>1.6});
RPlot($plot, $x, $y, {CUT=>1.2, COLOR=>'GREEN'});
$plot->line ($x, $yf);
$plot->close;
}
