
#this module takes care of calling a given software
#and creates all configuration files in the batch mode

use strict;
#no strict "refs";


use Common::misc;
use Sex::RunSEx;
use Cwd 'chdir';

#use vars qw/$checktop $checklist/;


sub runSoft {

my $soft=shift;
my $doit=shift;


my $inlist="";
my $outlist="";
my $final_outlist="";


#this is the number of errors returned by tasks; if it >0 then something is wrong  
my $ret=0;

if ($main::DEBUG)  {print ("#DEBUG Configuration file: $main::ParFile\n")}


my $hdr="*************************************************\n";;
#my $now=Misc::mkdate();
my $now=&mkdate;
my $mode='';
if ($main::redmode eq "listonly") {$hdr=$hdr."$now - $soft - LISTONLY mode";$mode="listonly"}
elsif ($main::redmode eq "mklists") {$hdr=$hdr."$now - $soft - MKLISTS mode";$mode="mklists"}
else  {$hdr=$hdr."$now - $soft - BATCH mode";$mode="batch"}

my $l;

  if ($doit eq "bias") {$l="Making BIAS frames"}
   elsif ($doit eq "dark") {$l="Making DARK frames"}
   elsif ($doit eq "dflat") {$l="Making DOME FLAT frames"}
   elsif ($doit eq "tflat") {$l="Making TWILIGHT FLAT frames"}
   elsif ($doit eq "sflat") {$l="Making SUPERFLAT frames"}
   elsif ($doit eq "fringe") {$l="Making FRINGE frames"}
   elsif ($doit eq "science") {$l="Processing SCIENCE frames"}


if ($main::interface eq 'gui') {   #this only applies to the gui mode
#Updates the working directory
    my $d=$main::WORK_DIR;
    chdir "$d";

 } #end if GUI mode



$soft=uc($soft);



if (! -d $main::OUTDIR) {system ("mkdir $main::OUTDIR")}
if (! -d $main::STOREDIR) {system ("mkdir $main::STOREDIR")}
if (! -d $main::TMPDIR) {system ("mkdir $main::TMPDIR")}
if (! -d $main::PSDIR) {system ("mkdir $main::PSDIR")}

if ($soft eq 'FLIPS') {$ret=doFlips($doit)}
elsif ($soft eq 'PDL') {$ret=doPdl($doit)}



return $ret;

} #end sub runSoft


sub AskCleanup
{
  my $list=shift;

                   open (FILE, $list);
                   my $dfile=0;
                   while (<FILE>) {
                            chomp ($_); 
                            my $line=$_;
			    chomp ($line);
			    my @info=split(/\t/, $line);
			    my $file=$info[0];
			    $file=~tr/ //d;
                            if ($file !~ /.fits/) {$file=$file.".fits"}
			    #print "#DEBUG Removing $file\n";
			    if ($main::redmode ne "listonly") {
                                if (-e $file) {system ("rm $file"); $dfile++ } 
			    } else {print "Would remove file: $file\n"}
			}

return $dfile;
        
} #end AskCleanup

#///////////////////////////////////////////////////////////////////////
# Here are the subs which handle the reduction from different softwares
# - doFlips (not implemented)
# - doPDL
#///////////////////////////////////////////////////////////////////////


sub doFlips {
    require Flips::get_params;

  my $doit=shift;

  my $tmplist="";

#if ($redmode eq "RUN" || $redmode eq "listonly") {&get_params_flips::mkConfig($doit)}

   my $ret=0;

   my ($inlist, $outlist, $final_outlist);


   $inlist="";
   $outlist="";


  if ($doit eq "bias") {
#actually, for FLIPS dark and biases are the same thing.....
    $ret=&get_params_flips::mkform('biasred', $inlist, \$outlist);
    my $ninlist=$outlist;
    if ($ret==0) {
      $ret=&get_params_flips::mkform('biasmode',$ninlist);
      if ($ret==0) {$ret=&get_params_flips::mkform('biascomb',"",$final_outlist);}
    }
    if ($ret==0) {$tmplist=$ninlist}      
  } 
elsif ($doit eq "dark") {
    $ret=&get_params_flips::mkform('darkred', $inlist, \$outlist); 
    my $ninlist=$outlist;
    if ($ret==0) {
         $ret=&get_params_flips::mkform('darkmode',$ninlist);
         if ($ret==0) {$ret=&get_params_flips::mkform('darkcomb',"",\$final_outlist);}
       }  
    if ($ret==0) {$tmplist=$ninlist}  
  }  
  
  elsif ($doit eq "flat") {
         $ret=&get_params_flips::mkform('flatred', $inlist, \$outlist);  
         my $ninlist=$outlist;
	 
         if ($ret==0) {
             $ret=&get_params_flips::mkform('flatmode',$ninlist,\$outlist);
             if ($ret==0) {$ret=&get_params_flips::mkform('flatcomb',"", \$final_outlist)}

              #This will create a file "flatmode.dat" containing the modes of the flat; used in the ccdred step 
                if ($ret==0) {$ret=&get_params_flips::mkform('flatnorm',$final_outlist)}
          }
       if ($ret==0) {$tmplist=$ninlist}    
  } 
  elsif ($doit eq "sflat") {
#smooth  the sflat after combining       
   
         print "sorry, still not implemented !!!!!!!!!!!!\n";
  }
  elsif ($doit eq "science") {
        $ret=&get_params_flips::mkform('scienceccdred',$inlist, \$outlist);
        my $ninlist=$outlist;
         if ($ret==0) {
             $ret=&get_params_flips::mkform('scienceccdmode',$ninlist,\$outlist);
             if ($ret==0) {$ret=&get_params_flips::mkform('scienceccdcomb',"",\$final_outlist)}
          }
       if ($ret==0) {$tmplist=$ninlist}     
  }

# THIS WILL DELETE INTERMEDIATE FILES !!!!!!!!!!!!!!!!!!!
if ($ret==0 && $doit ne "science" && $main::CLEAN eq 'yes') {&AskCleanup($tmplist)}
  
  return $ret;
   
}

sub doPdl {
  require PDL::PDLfuncs;

  my $doit=shift;

#Meaning of return: $ret==0 No problem
#                   $ret<0  Warnings
#                   $ret>0  Errors

    my $inlist=$main::params->{$doit}{input}{Value};
    my $outlist=$main::params->{$doit}{output}{Value};
    my $tmplist=&main::mktList($inlist);

    if ($doit eq 'science') {$tmplist=$outlist}


    # First process frames
     my $wclock0=time;
     my $cpu0=(times)[0];

#     system ("rm $tmplist") if (-e $tmplist);
    my ($ret, $proc)=&PDLfuncs::ccdproc($inlist, $tmplist, $doit);
     #return if ($proc==0);   #No file written, so return
         if ($proc==0) {$tmplist=$inlist} #No file needed processing, so only combine frames
         elsif ($ret >0) {
            my $msg=sprintf("%d errors occurred while processing the $doit frames", $ret);
	    &main::mkLog($msg,"W",'ccdproc') ;
	    return
         }
    if ($doit eq 'science' &&  
	$main::params->{science}{weight}{Value} eq 'yes') {
       my $wfile=$main::params->{science}{wout}{Value};
       my $wproc=0; my $fproc=0;
       open (WFILE, "$wfile");
       while (<WFILE>) {
	 chomp ($_); 
	 $wproc++;
	 $fproc++ if (-e $_);
       }
       close (WFILE);
       &main::SumList($wfile, 'WMAPS', $doit, $wproc, $fproc);
    }

   if ( ($doit eq 'sflat' && $main::params->{sflat}{preproc}{Value} eq 'SEx' ) 
         || $doit eq 'fringe' ) {
       my $soutlist='';
       my $dt_outlist='';
       if ($proc==0) {$tmplist=$inlist; $ret=0};  #no processing was required
       my $msg="Running SEx on list $tmplist";
       &main::mkLog($msg) ;


# == if maximum cleanup is not requested, then when fringe frames are extracted
#    we also create detection frames that will be used when rescaling

      if ($ret==0 && $doit eq 'fringe' && $main::CLEAN ne 'all' ) {
       $ret=doSEx($tmplist,$doit, \$soutlist, \$dt_outlist);
     } else {$ret=doSEx($tmplist,$doit, \$soutlist)}

 
      if ($ret==0 && $main::CLEAN eq 'all' && $main::redmode ne "listonly" ) {
          &AskCleanup($tmplist) }

       $tmplist=$soutlist;
   }

    if ($main::redmode eq 'RUN') {
               my $cpu1=(times)[0];
               my $wclock1 = time;
	    my $st=sprintf "$doit/PROC ($proc files): %.2fs (user), %.2fs (CPU)\n", $wclock1-$wclock0,$cpu1-$cpu0;

               print $st;
           open (SFILE, ">>$SFILE");
	       print SFILE $st;
	   close (SFILE);

    };
  
  if ($doit ne 'science') {
    # Now combine frames
    $wclock0=time;
    $cpu0=(times)[0];
    
    my $ncomb; #how many files were written
    ($ret, $ncomb)=&PDLfuncs::combine($tmplist, $outlist, $doit);
    if ($ret >0) {
      my $msg=sprintf("%d errors occurred while combining the $doit frames", $ret);
      &main::mkLog($msg,"W",'combine') ;
    }

#Should we smooth the sflat/fringe master frames ?
    if ($ret==0) { 
#      if ( ($doit eq 'fringe' && $main::params->{fringe}{smooth}{Value}>1) || 
#	   ($doit eq 'sflat' && $main::params->{sflat}{preproc}{Value} eq 'smooth')  ) {
     if ($doit eq 'sflat' && $main::params->{sflat}{preproc}{Value} eq 'smooth')  {
	       my $soutlist="";
               my $sret=&main::doSEx($outlist, 'smooth', \$soutlist);
	       if ($main::redmode eq 'RUN' && $sret==0) {
# replace the list with that containing the smoothed frames
# Dependening on the "clean" mode, move or erase the non smoothed frames
		 open (ILIST, "<$outlist");
		 while (<ILIST>) {
		   chomp ($_);
		   my $infile=$_;
		   my @s=split (/\//, $infile);
		   if ($main::CLEAN eq 'no') {
		     my $outfile=$TMPDIR.'/'.$s[-1];
		     system ("mv $infile $outfile");
		   } else {
		     system ("rm $infile");
		   }
		 }
		 close (ILIST);
		 system ("mv $soutlist $outlist");
	       }
      }
    }
    
    
    if ($main::redmode eq "RUN") {
      my $cpu1=(times)[0];
      my $wclock1 = time;
	    my $st=sprintf "$doit/COMBINE ($ncomb files):  %.2fs (user), %.2fs (CPU)\n", $wclock1-$wclock0,$cpu1-$cpu0;

               print $st;
           open (SFILE, ">>$SFILE");
	       print SFILE $st;
	   close (SFILE);

    } 
  }


# We need to: - Bring the background to the same level for science images
#             - Make a mosaic if requested

my $dolevel='no';
my $mkmos=$main::params->{$doit}{mkmosaic}{Value};

$dolevel='yes' if ($doit eq 'science' && $main::params->{science}{level}{Value} eq 'yes');

  if ($dolevel eq 'yes' || $mkmos eq 'yes') { 
    $wclock0=time;
    $cpu0=(times)[0];
      
    my $msg="Making mosaic for list $outlist";
      &main::mkLog($msg) ;
      my $nmos=&PDLfuncs::domosaic($outlist, $main::params, 
               {LEVEL=>$dolevel, UPDATE=>'yes', MKMOS=>$mkmos});

    if ($main::redmode eq "RUN") {
      my $cpu1=(times)[0];
      my $wclock1 = time;
	    my $st=sprintf "$doit/LEVEL[$dolevel] MOSAIC[$mkmos] ($nmos files):  %.2fs (user), %.2fs (CPU)\n", $wclock1-$wclock0,$cpu1-$cpu0;

               print $st;
           open (SFILE, ">>$SFILE");
	       print SFILE $st;
	   close (SFILE);

    } 

  }



# THIS WILL DELETE INTERMEDIATE FILES !!!!!!!!!!!!!!!!!!!


if ($ret==0 && $doit ne "science" && $main::CLEAN ne 'no' && $main::redmode ne "listonly" ) {
    &AskCleanup($tmplist) unless ($main::CLEAN eq 'calib' && $doit eq 'fringe'); 
}
else {print "$tmplist not erased \n"}



 return $ret;

}



1;
