#!/usr/local/bin/perl 

package displog;

use Tk;
use Tk::ProgressBar;

use vars qw /$mw $logfile $varstep $varfname $svp $status_var $fname/;
use vars qw /$procInd $checklist $id_timer/;

sub Display
{

$mw=$main::top;

my $frame=$mw->Frame->pack(-side=>'bottom', -fill=>'both', -expand=>0);


$checklist=$mw->Scrolled(qw/Text -width 80 -height 15 -setgrid 1
                              -scrollbars se -state disabled/);  #do not allow the user to write in the window
$checklist->pack(qw/-expand 1 -fill both -side top/);

#$checklist->tagConfigure('bold', -font=>
#   "-*-Courier-Medium-B-Normal--*-120-*-*-*-*-*-*");
$checklist->tag(qw/configure red -foreground red/);
$checklist->tag(qw/configure yellow -foreground gold3/);

$status_var=0;
$svp='0 %';
my $step='STEP';
$varstep=$step.' - waiting';

$fname='IMAGE ';
$varfname=$fname.' - none';

 my  $procInd=$frame->ProgressBar(
            -borderwidth => 2,
            -relief => 'sunken',
            -length => 500,
            -width => 20,
            -padx => 2,
            -pady => 2,
            -variable => \$status_var,
            -colors => [0 => 'green', 33=>'yellow', 66=>'red'],
            -resolution => -1,
            -blocks => 20,
            -anchor => 'w',
            -from => 0,
            -to => 100
        )->pack(
            -padx => 10,
            -pady => 10,
           # -ipadx => 20,
           #  -ipady => 2,
            -side => 'top',
            # -fill => 'both',
            -expand => 0,
        );

my $lab=$frame->Label(-textvariable=>\$svp)->pack(
             -padx => 1, -pady=> 1, -expand=>0,#-in => $procInd
                );


$counter = $frame->Label(-relief => 'raised', -width => '10', -textvariable =>
\$time_str ) ;

$counter->pack(-side => 'right');

$seconds = 0;
$minutes = 0;
$hours=0;
$time_str = "00:00:00";
$stopped = 1;

$logfile='logfile';
my $lentry= $frame->Label(-relief =>
'raised',-width=>'25', -textvariable=>\$logfile)->pack(
        -padx => 1, -pady=> 1, -expand=>0, -side=>'left');


my $lstep=$frame->Label(-relief =>
'raised',-width=>'25', -textvariable=>\$varstep)->pack(
        -padx => 1, -pady=> 1, -expand=>0, -side=>'left');

my $lfname=$frame->Label(-relief =>
'raised',-width=>'50', -textvariable=>\$varfname)->pack(
        -padx => 1, -pady=> 1, -expand=>0, -side=>'left');

}


sub check {
  my  $com = shift;


  my ($line, $swhat);

    #if ($com =~ /PID/) {my @s=split (/:/, $com); $main::bpid=$s[1];
    #}

    if ($com =~ /next/) {
warn "---------------> setting NextProc to 1";
          $main::NextProc=1;
         }
   elsif ($com =~ /count/) {
          chomp($com);
          my @s=split(/ /,$com);
          $status_var=$s[1];
          $svp=sprintf("%3d", $status_var).'%';
          if ($#s==2) {
	    my @imn=split(/\//, $s[2]);
	    $varfname=sprintf("%s - %s", $fname, $imn[-1]);
	  }
         $mw->update();
     }
        elsif ($com =~ /^Applying/) {
	        #Timer('reset');
		my @s=split(/ /, $com,2);
                $swhat=lc($s[1]);
                chomp($swhat);
		$varstep=$step." @ $swhat";
	    }
       else {
       my $row=lc($com);
        $checklist->configure(-state=>'normal');

           if ($row =~ /<configfile>/) {              
              #$logfile=$main::RunConf->{NAME};
	      my @s=split(/ /, $row,3);
               $logfile=$s[1];
               chomp($logfile);	      
           }
           elsif  ($row =~ /<\/proc>/) {
              $main::NextProc=1;
           }
           elsif ($row =~ /<procstep>/) {
               my @s=split(/ /, $row,2);
               $step=uc($s[1]);
               chomp($step);
               $varstep=$step.' - ';
	       	$swhat=''; 
		&Timer('start');      
           }	   
          elsif ($row =~ /<\/procstep>/ || $row eq 'abort') {
               $varstep=$step.' - done';
	       $swhat='';
	       &Timer('off');
	       &main::UpdateForm($main::RunConf);
               $main::NextProc=-1 if ($row eq 'abort'); 
           }	   
	    elsif ($row =~ /^processing/) {
	        Timer('reset');
	      }
	    elsif ($row =~ /^combining/) {
	        Timer('reset');
	        $swhat='combining';
		$varstep=$step." - $swhat";
	    }
            elsif ($row =~ /sex/) {
               Timer('reset');
               $swhat='SExtractor';
	       $varstep=$step." - $swhat"; 
            } 
            elsif ($row =~ /mosaic/) {
               Timer('reset');
               $swhat='Mosaic';
	       $varstep=$step." - $swhat"; 
            } 
            if ($row =~ /error/) {$checklist->insert('end', $com,qw(red));}
           elsif ($row =~ /warning/) {$checklist->insert('end', $com,qw(yellow));}
           else {$checklist->insert('end', $com)}
       $checklist->yview('end');
       $checklist->configure(-state=>'disabled');
     }

}

sub tick {

    return if ($stopped);
    $id_timer=$mw->after(5000, sub {&tick});  
    $seconds += 5;
    if ($seconds >= 60) {
        $seconds = 0;
        $minutes++;
    }

    if ($minutes >= 60) {
        $minutes = 0;
        $hours++;
    }
    
     $time_str=sprintf("%02d:%02d:%02d", $hours,$minutes,$seconds);

}

sub Timer {
my $what=shift;

#warn "!!! Timer --- $what\n"; 
if ($what eq 'start') {
#warn "Starting timer !\n";
   $hours=$seconds=$minutes=0; 
   $stopped=0;  
   &tick;
 }  
elsif ($what eq 'reset') {
   $hours=$seconds=$minutes=0;   
} else {
#warn "restting timer !\n";
      $mw->afterCancel($id_timer); $id_timer=0;
      $stopped=1; $hours=$seconds=$minutes=0; }
}

1;
