package showCCD;

#use Tk;
use strict;

use vars qw/$width $height $soffx $soffy $dx $dy $nc $nc_id/;
use vars qw/$canvas/;
use vars qw/$gnx $gny @ccd_id @os_sec @trim_sec @ccd_sec @osv @trv $max/;

sub Show
{

my %user=@_;

my $conf;
if (exists $user{CONF}) {$conf= $user{CONF}} else {return}

 @os_sec=$conf->Section(step=>'overscan');
 @trim_sec=$conf->Section(step=>'trim');
 @ccd_sec=$conf->Section(step=>'general');
 @ccd_id=$conf->CCDid();
 $gnx=$conf->{NCCDX};
 $gny=$conf->{NCCDY};


if ($#ccd_sec==-1) {
  print "tool failed, ccdsec not defined !\n";
  return
}


$max=$gnx*$gny;


$width=300;          #the size in pixels of the 'whole' panel
$height=1.5*$width;
$soffx=40;  $soffy=10;  #the distances in pixels bewteen the "panels"
$dx=200; $dy=500;  #the distances in pixels between adjacent CCDs

my $mw = $main::top->Toplevel;
$mw->title("Mosaic properties");

my $c = $mw->Scrolled("Canvas", -cursor => "crosshair",
             -height=>$height, -width=>3*$width)->pack(
             -side => "left", -fill => 'both', -expand => 1);
	     
$canvas = $c->Subwidget("canvas");	


DisplayAll();
   $nc=($canvas->gettags('N00'))[2];
   $nc_id= $nc;
   $nc =~ tr/N//d;	  

my ($wux, $wuy, $wlx, $wly)=$canvas->bbox("whole");	  
DisplayAll(offx=>$wlx, nr=>0, panel=>'single');
 my ($ux, $uy, $lx, $ly)=$canvas->bbox("single");

#Draw the CCD entries

	        my $lxs=$lx+45; 
		
		my $txt=$canvas->Label(-text=>'CCD');
		$canvas->createWindow($lxs,$uy,-window=>$txt);
	
	       $lxs=$lx+60; 
	       
	       foreach my $i (0..$#ccd_sec) {
	         $lxs+=50;
		 my $entry=$canvas->Entry(-textvariable=>\$ccd_sec[$i], -state=>'disabled', 
		  -width=>4);
	         $canvas->createWindow($lxs,$uy,-window=>$entry);	    
               } 
	       
	       
#Draw the TRIM entries
	       
	        $uy+=40;
		
		$lxs=$lx+45; 
		
		$txt=$canvas->Label(-text=>'TRIM');
		$canvas->createWindow($lxs,$uy,-window=>$txt);
		
		
		$lxs=$lx+60; 
		
		 @trv=();		
	        foreach my $i (0..3) {
	         $lxs+=50;
		 push @trv, $trim_sec[0][$i];
		 my $entry=$canvas->Entry(-textvariable=>\$trv[$i], -cursor=>'hand2',  -width=>4);
	         $canvas->createWindow($lxs,$uy,-window=>$entry);	    
               } 


#Draw the OVERSCAN entries	
       
	        $uy+=40;

		$lxs=$lx+45; 
		
		$txt=$canvas->Label(-text=>'OVERSCAN');
		$canvas->createWindow($lxs,$uy,-window=>$txt);


	        $lxs=$lx+60; 
		 @osv=();
	        foreach my $i (0..3) {
	         $lxs+=50;
		 push @osv, $os_sec[0][$i];
		 my $entry=$canvas->Entry(-textvariable=>\$osv[$i],  -cursor=>'hand2', -width=>4);
	         $canvas->createWindow($lxs,$uy,-window=>$entry);	    
               } 
	       
	       
	       $uy+=30;
	        $lxs=$lx+50;
	       my $bt;
	       
	       $bt=$canvas->Button(-text=>"Apply",
                             -command=>(sub{
			       $canvas->delete($nc_id);
			       foreach my $i (0..3) {
			         $os_sec[$nc][$i]=$osv[$i];
				 $trim_sec[$nc][$i]=$trv[$i];
			       }
			     DisplayAll(nr=>$nc, panel=>'whole');
			     DisplayAll(offx=>$wlx, nr=>$nc, panel=>'single');
			     })
			     );
              $canvas->createWindow($lxs,$uy,-window=>$bt);
	      
	      
	      $lxs+=100;
	       $bt=$canvas->Button(-text=>"Apply to ALL",
                             -command=>(sub{			     
			     $canvas->delete('whole','single');
			     foreach my $i (0..3) {
			      foreach my $j (0..$max-1) {
			     	    $os_sec[$j][$i]=$osv[$i];
				    $trim_sec[$j][$i]=$trv[$i];
				  }
				}    		     
			     DisplayAll(panel=>'whole');
			     DisplayAll(offx=>$wlx, nr=>$nc, panel=>'single');
			     })
			     );
              $canvas->createWindow($lxs,$uy,-window=>$bt);
	      
	      $lxs=$lx+70;
	      $uy+=50;
	       $bt=$canvas->Button(-text=>"CLOSE",
                             -command=>(sub{
			      if ($user{update} eq 'yes') { 
			         $conf->Section(step=>'overscan', array=>\@os_sec);
                                 $conf->Section(step=>'trim', array=>\@trim_sec);	 
			      }
			      $mw->destroy;
			     })
			     );
              $canvas->createWindow($lxs,$uy,-window=>$bt);
	      
$canvas->configure(-scrollregion =>[$canvas->bbox("all")]);	 


$canvas->waitWindow();


#MainLoop;
}


sub DisplayAll {


my %user=@_;


my $wx=$ccd_sec[1]-$ccd_sec[0];
my $wy=$ccd_sec[3]-$ccd_sec[2];

my $nr=-1;
$nr=$user{nr} if (exists $user{nr}); 

my $tag='whole';
$tag=$user{panel} if (exists $user{panel});

my $nx=$gnx; my $ny=$gny;
if ($tag eq 'single') {$nx=1; $ny=1}

my $offx=$soffx;
my $offy=$soffy;

if (exists $user{offx}) {$offx+=$user{offx}}

my $xscale=(.8*$width)/($nx*($wx+$dx));
my $yscale=(.8*$height)/($ny*($wy+$dy));



for my $i (0..$ny-1) {
  for my $j (0..$nx-1) {
   my $x=$offx+$xscale*(($wx+$dx)*$j+$wx/2);
   my $y=$offy+$yscale*(($wy+$dy)*$i+$wy/2);
   my ($nccd);
   if ($tag eq 'whole') {
   $nccd=$j+$nx*$i; 
   next if($nr!=-1 && $nccd!=$nr)} 
   else{$nccd=$nr}
   
   my $n=sprintf("%02d",$nccd);
   my $s='N'.$n;      #define the TAG as the SEQUENTIAL number of the CCD !
   my $lidx=$ccd_id[$nccd];  #define the LABEL as the INDEX/NAME of the CCD
   $canvas->createText($x, $height-$y, -text=>$lidx, -tags=>[$tag, 'text', $s]);
  
  my ($x1,$x2, $y1, $y2);
  
  #draw the ccd section
    
   $x1=$offx+$xscale*(($wx+$dx)*$j+$ccd_sec[0]);
   $x2=$x1+$xscale*($ccd_sec[1]-$ccd_sec[0]);
   $y2=$offy+$yscale*(($wy+$dy)*$i+$ccd_sec[2]);
   $y1=$y2+$yscale*($ccd_sec[3]-$ccd_sec[2]);
   $canvas->createRectangle($x1, $height-$y1, $x2, $height-$y2,
     -width => 1, -tags => [$tag, 'ccd',$s]);
   
    
      
  #draw the data section
  
   $x1=$offx+$xscale*(($wx+$dx)*$j+$trim_sec[$nccd][0]);
   $x2=$x1+$xscale*($trim_sec[$nccd][1]-$trim_sec[$nccd][0]);
   $y2=$offy+$yscale*(($wy+$dy)*$i+$trim_sec[$nccd][2]);
   $y1=$y2+$yscale*($trim_sec[$nccd][3]-$trim_sec[$nccd][2]);
   $canvas->createRectangle($x1, $height-$y1, $x2, $height-$y2,
     -width => 1, -tags => [$tag, 'trim',$s], -fill=>'yellow');
   
    
   #draw the overscan section
   
    $x1=$offx+$xscale*(($wx+$dx)*$j+$os_sec[$nccd][0]);
    $x2=$x1+$xscale*($os_sec[$nccd][1]-$os_sec[$nccd][0]);
    $y2=$offy+$yscale*(($wy+$dy)*$i+$os_sec[$nccd][2]);
    $y1=$y2+$yscale*($os_sec[$nccd][3]-$os_sec[$nccd][2]);
   $canvas->createRectangle($x1, $height-$y1, $x2, $height-$y2,
     -width => .5, -tags => [$tag, 'overscan',$s], -fill=>'red');
        
   
                 
 }
} 


$canvas->raise("text");

 if ($tag eq 'whole' && $nr == -1) {
   my $old_fill = '';
    $canvas->bind('whole', '<Any-Enter>' => [\&cscroll_enter, \$old_fill]);
    $canvas->bind('whole', '<Any-ButtonPress>' => (
         sub{
	   $nc=($canvas->gettags('current'))[2];
	   $nc_id=$nc;
	   $nc =~ tr/N//d;
	   foreach my $i (0..3) {
	      $osv[$i]=$os_sec[$nc][$i];
	      $trv[$i]=$trim_sec[$nc][$i];
	   }
	   my ($wux, $wuy, $wlx, $wly)=$canvas->bbox("whole");	  
	   my @list=$canvas->gettags('single');
	   if ($#list >-1) {
	       $canvas->delete("single");
	    }   
	       DisplayAll(nr=>$nc, offx=>$wlx, panel=>'single');
	            
	  }  
	 )
	      
       );
    
    $canvas->bind('whole', '<Any-Leave>' => [\&cscroll_leave, \$old_fill]);
 }

}



sub cscroll_enter {

    my($c, $old_fill) = @_;

    my $id = $c->find(qw/withtag current/);
    $$old_fill = ($c->itemconfigure($id, -fill))[4];
    $c->itemconfigure($id, -fill => 'SeaGreen1');
  

} # end cscroll_enter

sub cscroll_leave {

    my($c, $old_fill) = @_;

    my $id = $c->find(qw/withtag current/);
    $id-- if ($c->gettags('current'))[0] eq 'text';
    $c->itemconfigure($id, -fill => $$old_fill);

} # end cscroll_leave

1;
