package esowfi;

use Instr::ESO;
@ISA = ("ESO");

sub init_props {
 my $self=shift;

$self->{_properties} =
{
   MINCCD=> 1,
   NCCDX=>  4,
   NCCDY => 2,
   NUMCCD=> 8,
   data => {        
     section=>[]
   },
    trim => {
     section =>[]
   },
   overscan => {
     method=>'block',  #block average 
     order=>50,        #size of the blocks
     section=>[],
   },  
   fringe => {
      group=>'all'    
	     },
   sflat => {
      group=>'all'    
	     },
   FITS_TYPE => 'MEF',
 #define the TRUE ccd number as a function of its position in the MEF  
   CCDid => [1,2,3,4,8,7,6,5] , 
 #define the geometrical position of the CCD 
  # (0 = lower left, 7=upper right)  
   CCDpos => [4,5,6,7,0,1,2,3]
};

#set sections
#(see  http://www.eso.org/science/eis/eis_proj/pilot/wfi/wfi_hdr.cl)

$self->Section(step=>'data',c1=>1, c2=>2142, r1=>1, r2=>4128);
my $nccd=$self->{_properties}{NUMCCD};

#set overscan and trim sections 

foreach my $i (0..$nccd-1) {
 # ======= overscan 
  if ($i<4) {
    $self->Section(step=>'overscan', ccd=>$i,c1=>10, c2=>40, r1=>40, r2=>4100);  
 } else {
    $self->Section(step=>'overscan', ccd=>$i,c1=>2100, c2=>2130, r1=>40, r2=>4100);
 }
# ======= trim
    if ($i<4) {      
      $self->Section(step=>'trim', ccd=>$i,c1=>60, c2=>2093, r1=>30, r2=>4126);
     } 
    elsif($i==7) {
      $self->Section(step=>'trim', ccd=>$i,c1=>60, c2=>2093, r1=>2, r2=>4098);
    }
    else {
       $self->Section(step=>'trim', ccd=>$i,c1=>50, c2=>2083, r1=>2, r2=>4098);  
     }
  }




} #end sub init_props


 1;
