package uh8k;

use Instr::CFHT;

@ISA = ("CFHT");

sub init_props {
 my $self=shift;

$self->{_properties} =
{
   MINCCD=> 0,
   NCCDX=> 4,
   NCCDY => 2,
   NUMCCD=> 8,
   data => {        
     section=>[]
   },
    TRIM => {
     section =>[]
   },
   OVERSCAN => {
     section=>[],
   },  
   FITS_TYPE => 'SIMPLE',

   CCDid => [0,1,7,6,2,3,5,4]
};

#set sections


$self->Section(step=>'data',c1=>1, c2=>2080, r1=>1, r2=>4100);
my $nccd=$self->{_properties}{NUMCCD};

#set overscan and trim sections
foreach my $i (0..$nccd-1) {
    $self->Section(step=>'overscan', ccd=>$i,c1=>2069, c2=>2079, r1=>100, r2=>4000);  
    $self->Section(step=>'trim', ccd=>$i,c1=>6, c2=>2045, r1=>5, r2=>4096);
  }

} #end sub init

 1;
