
use strict;

use vars qw(@SExConf);


sub InitSEx
{

@SExConf=(

    {
   COMM =>  ' Default configuration file for SExtractor V1.2b14 - > 2.0',
    }, 

    {
   COMM =>  ' EB 23/07/98',
    }, 

    {
   COMM =>  ' (*) indicates parameters which can be omitted from this config file.',
    }, 

    {
   COMM =>  '-------------------------------- Catalog ------------------------------------',
    }, 

    {
   KEY  =>  'CATALOG_NAME',
   VAL  =>  'sex.cat',
   COMM =>  ' name of the output catalog',
    }, 

    {
   KEY  =>  'CATALOG_TYPE',
   VAL  =>  'NONE',
   COMM =>  ' "NONE","ASCII_HEAD","ASCII","FITS_1.0"',
    }, 

    {
   COMM =>  ' or "FITS_LDAC"',
    }, 

    {
   KEY  =>  'PARAMETERS_NAME',
   VAL  =>  $main::SExPars,
   COMM =>  ' name of the file containing catalog contents',
    }, 

    {
   COMM =>  '------------------------------- Extraction ----------------------------------',
    }, 

    {
   KEY  =>  'DETECT_TYPE',
   VAL  =>  'CCD',
   COMM =>  ' "CCD" or "PHOTO" (*)',
    }, 

    {
   KEY  =>  'FLAG_IMAGE',
   VAL  =>  'flag.fits',
   COMM =>  ' filename for an input FLAG-image',
    }, 

    {
   KEY  =>  'DETECT_MINAREA',
   VAL  =>  '5',
   COMM =>  ' minimum number of pixels above threshold',
    }, 

    {
   KEY  =>  'DETECT_THRESH',
   VAL  =>  '1.5',
   COMM =>  ' <sigmas> or <threshold>,<ZP> in mag.arcsec-2',
    }, 

    {
   KEY  =>  'ANALYSIS_THRESH',
   VAL  =>  '1.5',
   COMM =>  ' <sigmas> or <threshold>,<ZP> in mag.arcsec-2',
    }, 

    {
   KEY  =>  'FILTER',
   VAL  =>  'N',
   COMM =>  ' apply filter for detection ("Y" or "N")?',
    }, 

    {
   KEY  =>  'FILTER_NAME',
   VAL  =>  "$main::SExConv",
   COMM =>  ' name of the file containing the filter',
    }, 

    {
   KEY  =>  'DEBLEND_NTHRESH',
   VAL  =>  '32',
   COMM =>  ' Number of deblending sub-thresholds',
    }, 

    {
   KEY  =>  'DEBLEND_MINCONT',
   VAL  =>  '0.005',
   COMM =>  ' Minimum contrast parameter for deblending',
    }, 

    {
   KEY  =>  'CLEAN',
   VAL  =>  'Y',
   COMM =>  ' Clean spurious detections? (Y or N)?',
    }, 

    {
   KEY  =>  'CLEAN_PARAM',
   VAL  =>  '1.0',
   COMM =>  ' Cleaning efficiency',
    }, 

    {
   KEY  =>  'MASK_TYPE',
   VAL  =>  'CORRECT',
   COMM =>  ' type of detection MASKing: can be one of',
    }, 

    {
   COMM =>  ' "NONE", "BLANK" or "CORRECT"',
    }, 

    {
   COMM =>  '------------------------------ Photometry -----------------------------------',
    }, 

    {
   KEY  =>  'PHOT_APERTURES',
   VAL  =>  '5',
   COMM =>  ' MAG_APER aperture diameter(s) in pixels',
    }, 

    {
   KEY  =>  'PHOT_AUTOPARAMS',
   VAL  =>  '2.5, 3.5',
   COMM =>  ' MAG_AUTO parameters: <Kron_fact>,<min_radius>',
    }, 

    {
   KEY  =>  'SATUR_LEVEL',
   VAL  =>  '50000.0',
   COMM =>  ' level (in ADUs) at which arises saturation',
    }, 

    {
   KEY  =>  'MAG_ZEROPOINT',
   VAL  =>  '0.0',
   COMM =>  ' magnitude zero-point',
    }, 

    {
   KEY  =>  'MAG_GAMMA',
   VAL  =>  '4.0',
   COMM =>  ' gamma of emulsion (for photographic scans)',
    }, 

    {
   KEY  =>  'GAIN',
   VAL  =>  '0.0',
   COMM =>  ' detector gain in e-/ADU.',
    }, 

    {
   KEY  =>  'PIXEL_SCALE',
   VAL  =>  '1.0',
   COMM =>  ' size of pixel in arcsec (0=use FITS WCS info).',
    }, 

    {
   COMM =>  '------------------------- Star/Galaxy Separation ----------------------------',
    }, 

    {
   KEY  =>  'SEEING_FWHM',
   VAL  =>  '1.2',
   COMM =>  ' stellar FWHM in arcsec',
    }, 

    {
   KEY  =>  'STARNNW_NAME',
   VAL  =>  'default.nnw',
   COMM =>  ' Neural-Network_Weight table filename',
    }, 

    {
   COMM =>  '------------------------------ Background -----------------------------------',
    }, 

    {
   KEY  =>  'BACK_SIZE',
   VAL  =>  '64',
   COMM =>  ' Background mesh: <size> or <width>,<height>',
    }, 

    {
   KEY  =>  'BACK_FILTERSIZE',
   VAL  =>  '3',
   COMM =>  ' Background filter: <size> or <width>,<height>',
    }, 

    {
   KEY  =>  'BACKPHOTO_TYPE',
   VAL  =>  'GLOBAL',
   COMM =>  ' can be "GLOBAL" or "LOCAL" (*)',
    }, 

    {
   KEY  =>  'BACKPHOTO_THICK',
   VAL  =>  '24',
   COMM =>  ' thickness of the background LOCAL annulus (*)',
    }, 

    {
   COMM =>  '------------------------------ Check Image ----------------------------------',
    }, 

    {
   KEY  =>  'CHECKIMAGE_TYPE',
   VAL  =>  'NONE',
   COMM =>  ' can be one of "NONE", "BACKGROUND",',
    }, 

    {
   COMM =>  ' "MINIBACKGROUND", "-BACKGROUND", "OBJECTS",',
    }, 

    {
   COMM =>  ' "-OBJECTS", "SEGMENTATION", "APERTURES",',
    }, 

    {
   COMM =>  ' or "FILTERED" (*)',
    }, 

    {
   KEY  =>  'CHECKIMAGE_NAME',
   VAL  =>  'check.fits',
   COMM =>  ' Filename for the check-image (*)',
    }, 

    {
   COMM =>  '--------------------- Memory (change with caution!) -------------------------',
    }, 

    {
   KEY  =>  'MEMORY_OBJSTACK',
   VAL  =>  '2000',
   COMM =>  ' number of objects in stack',
    }, 

    {
   KEY  =>  'MEMORY_PIXSTACK',
   VAL  =>  '100000',
   COMM =>  ' number of pixels in stack',
    }, 

    {
   KEY  =>  'MEMORY_BUFSIZE',
   VAL  =>  '1024',
   COMM =>  ' number of lines in buffer',
    }, 

    {
   COMM =>  '----------------------------- Miscellaneous ---------------------------------',
    }, 

    {
   KEY  =>  'VERBOSE_TYPE',
   VAL  =>  'NORMAL',
   COMM =>  ' can be "QUIET", "NORMAL" or "FULL" (*)',
    }, 

    {
   COMM =>  '------------------------------- New Stuff -----------------------------------',
    }, 

     );
}

sub mkSExPars
{

  my $pfile=shift;
   open (PFILE, ">$pfile");

print PFILE "NUMBER\n\n";

print PFILE "#FLUX\_ISO\n";
print PFILE "FLUXERR\_ISO\n";
print PFILE "#MAG\_ISO\n";
print PFILE "#MAGERR\_ISO\n\n";

print PFILE "#FLUX\_ISOCOR\n";
print PFILE "#FLUXERR\_ISOCOR\n";
print PFILE "#MAG\_ISOCOR\n";
print PFILE "#MAGERR\_ISOCOR\n\n";

print PFILE "#FLUX\_APER(1)\n";
print PFILE "#FLUXERR\_APER(1)\n";
print PFILE "#MAG\_APER(1)\n";
print PFILE "#MAGERR\_APER(1)\n\n";

print PFILE "FLUX\_AUTO\n";
print PFILE "FLUXERR\_AUTO\n";
print PFILE "#MAG\_AUTO\n";
print PFILE "#MAGERR\_AUTO\n\n";

print PFILE "#FLUX\_BEST\n";
print PFILE "#FLUXERR\_BEST\n";
print PFILE "#MAG\_BEST\n";
print PFILE "#MAGERR\_BEST\n\n";

print PFILE "#KRON\_RADIUS\n";
print PFILE "#BACKGROUND\n\n";

print PFILE "#THRESHOLD\n";
print PFILE "#MU\_THRESHOLD\n";
print PFILE "#FLUX\_MAX\n";
print PFILE "#MU\_MAX\n";
print PFILE "#ISOAREA\_IMAGE\n";
print PFILE "#ISOAREA\_WORLD\n\n";

print PFILE "#XMIN\_IMAGE\n";
print PFILE "#YMIN\_IMAGE\n";
print PFILE "#XMAX\_IMAGE\n";
print PFILE "#YMAX\_IMAGE\n\n";

print PFILE "X\_IMAGE\n";
print PFILE "Y\_IMAGE\n";
print PFILE "#X\_WORLD\n";
print PFILE "#Y\_WORLD\n";
print PFILE "#ALPHA\_SKY\n";
print PFILE "#DELTA\_SKY\n";
print PFILE "#ALPHA\_J2000\n";
print PFILE "#DELTA\_J2000\n";
print PFILE "#ALPHA\_B1950\n";
print PFILE "#DELTA\_B1950\n\n";

print PFILE "#X2\_IMAGE\n";
print PFILE "#Y2\_IMAGE\n";
print PFILE "#XY\_IMAGE\n";
print PFILE "#X2\_WORLD\n";
print PFILE "#Y2\_WORLD\n";
print PFILE "#XY\_WORLD\n\n";

print PFILE "#CXX\_IMAGE\n";
print PFILE "#CYY\_IMAGE\n";
print PFILE "#CXY\_IMAGE\n";
print PFILE "#CXX\_WORLD\n";
print PFILE "#CYY\_WORLD\n";
print PFILE "#CXY\_WORLD\n\n";

print PFILE "#A\_IMAGE\n";
print PFILE "#B\_IMAGE\n";
print PFILE "#A\_WORLD\n";
print PFILE "#B\_WORLD\n\n";

print PFILE "#THETA\_IMAGE\n";
print PFILE "#THETA\_WORLD\n";
print PFILE "#THETA\_SKY\n";
print PFILE "#THETA\_J2000\n";
print PFILE "#THETA\_B1950\n\n";

print PFILE "#ELONGATION\n";
print PFILE "#ELLIPTICITY\n\n";

print PFILE "#ERRX2\_IMAGE\n";
print PFILE "#ERRY2\_IMAGE\n";
print PFILE "#ERRXY\_IMAGE\n";
print PFILE "#ERRX2\_WORLD\n";
print PFILE "#ERRY2\_WORLD\n";
print PFILE "#ERRXY\_WORLD\n\n";

print PFILE "#ERRCXX\_IMAGE\n";
print PFILE "#ERRCYY\_IMAGE\n";
print PFILE "#ERRCXY\_IMAGE\n";
print PFILE "#ERRCXX\_WORLD\n";
print PFILE "#ERRCYY\_WORLD\n";
print PFILE "#ERRCXY\_WORLD\n\n";

print PFILE "#ERRA\_IMAGE\n";
print PFILE "#ERRB\_IMAGE\n";
print PFILE "#ERRA\_WORLD\n";
print PFILE "#ERRB\_WORLD\n\n";

print PFILE "#ERRTHETA\_IMAGE\n";
print PFILE "#ERRTHETA\_WORLD\n";
print PFILE "#ERRTHETA\_SKY\n";
print PFILE "#ERRTHETA\_J2000\n";
print PFILE "#ERRTHETA\_B1950\n\n";

print PFILE "#FWHM\_IMAGE\n";
print PFILE "#FWHM\_WORLD\n\n";

print PFILE "#ISO0\n";
print PFILE "#ISO1\n";
print PFILE "#ISO2\n";
print PFILE "#ISO3\n";
print PFILE "#ISO4\n";
print PFILE "#ISO5\n";
print PFILE "#ISO6\n";
print PFILE "#ISO7\n\n";

print PFILE "FLAGS\n";
print PFILE "#IMAFLAGS\_ISO(1)\n";
print PFILE "#NIMAFLAGS\_ISO(1)\n\n";

print PFILE "#CLASS\_STAR\n";
print PFILE "#VIGNET(5,5)\n\n";


close (PFILE);

}


sub mkSExConv
{
  my $pfile=shift;
   open (PFILE, ">$pfile");
print PFILE "CONV NORM\n";
print PFILE "# 3x3 ``all-ground'' convolution mask with FWHM = 2 pixels.\n";
print PFILE "1 2 1\n";
print PFILE "2 4 2\n";
print PFILE "1 2 1\n";

close(PFILE);
}



sub mkSExConf
{

my $pfile=shift;

open (FILE, ">$pfile"); 
my $entry;
foreach $entry (@SExConf) {
  my $nokey=0;
   if (exists $entry->{KEY}) {
      print FILE "$entry->{KEY}\t";
      if (exists $entry->{VAL}) {
           print FILE "$entry->{VAL}\t";
	}   
    } else {$nokey=1}
    if (exists $entry->{COMM}) {
        my $comm=$entry->{COMM};
         if ($nokey==1 && $comm !~ '--') {print FILE "\t\t\t"}
	 
           print FILE "#$comm";
	}   
  print FILE "\n";	
   }
   
 close (FILE);  



   
 }

1;
