
 use PDL;
 use PGPLOT;
 use  PDL::Graphics::PGPLOT;
 use PDL::Image2D;

 use Mylib::Corr;

sub calcoff {

my ($trgcat, $refcat)=@_;

if (! -e $trgcat) {$trgcat='/home/mario/Varie/Ast/486869o11MDFOfl.coo'}
if (! -e $refcat) {$refcat='/home/mario/Varie/Ast/486872o11MDFOfl.coo'}



my (@a, @d, @ar, @dr)=();

           open (FILE, $trgcat);
              while (<FILE>) {
               my ($ta, $td) = split(' ',$_,2);
	     #my ($ta, $td, $md) = split(' ',$_,3);
	          push (@a, $ta); push (@d, $td)
	       }
            close (FILE);


my $a=float(@a);
my $d=float(@d);

my ($amin, $amax)=(min($a), max($a));
my ($dmin, $dmax)=(min($d), max($d));

           open (FILE, $refcat);
              while (<FILE>) {
	     my ($ta, $td) = split(' ',$_,2);
	     # my ($ta, $td, $md) = split(' ',$_,3);
	     if ( ($ta >= $amin && $ta <=$amax) && ($td >= $dmin && $td <=$dmax)) {
               push (@ar, $ta); push (@dr, $td)
	       }
	      }
            close (FILE);



my $ar=float(@ar);
my $dr=float(@dr);

#first find an approximate shift
my $nc;
($xshift, $yshift, $nc)= docorr($a, $d, $ar, $dr, 0,0, 500,500,5,5); 


print "Resolution 5: xs = $xshift, ys =  $yshift ($nc points)\n";


#now use a higher resolution
($xshift, $yshift, $nc) = docorr($a, $d, $ar,$dr, $xshift, $yshift, 15, 15 ,.5,.5,$lab); 
print "Resolution 0.5: xs = $xshift, ys =  $yshift ($nc points)\n";

#ok, last step !
#($xshift, $yshift, $nc) = docorr($a, $d, $ar,$dr, $xshift, $yshift, 1.5, 1.5,.05,.05,$lab); 

#print "Resolution 0.01: xs = $xshift, ys =  $yshift ($nc points)\n";


#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
# Make a plot

pgbegin(0,"over.ps/PS",1,1);

pgenv(min($a),max($a),min($d),max($d),0,1);

pgsch(0.7);
my $lab=sprintf "\\gD\\ga = %.4f \\gD\\gd= %.4f",$xshift, $yshift;
$lab="$astobs vs. $astrcat - ".$lab;
pglab('','',$lab);

pgsch(1.2);
pglab('\ga','\gd','');

#pgpoint(nelem($a),$a->get_dataref, $d->get_dataref,3);


pgpoint(nelem($ar),$ar->get_dataref, $dr->get_dataref,2);


#print min($ar), min($dr), max($ar), max($dr), "\n";


 my $x= $a + float($xshift);
 my $y= $d + float($yshift);
 pgpoint(nelem($x),$x->get_dataref, $y->get_dataref,4);

pgend();


#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

} #end sub calcoff

sub docorr
{

my ($a, $d, $ar, $dr, $x0, $y0, $xl, $yl, $xsize, $ysize, $lab)= @_;

# $c is the 2D array, $nc the number of elements in the given limits

my $coo=cat $a, $d; #create a 2D PDL
my $cooref=cat $ar, $dr; #create a 2D PDL

my $minx=$x0-$xl; 
my $miny=$y0-$yl;

my ($c, $nc)=Mylib::Corr::get_allcorr($coo,$cooref,2.*$xl,2.*$yl);

if ($nc>0) {$nc--}
else {print "NO POINT FOUND FOR DX = $xl, DY = $yl\n"; last}

#Compute the 2d histogram with the given bin size

my $xbins=int(2*$xl/$xsize+.5);
my $ybins=int(2*$yl/$ysize+.5);


my $h= histogram2d($c->slice("0:$nc,(0)"),$c->slice("0:$nc,(1)"),$xsize,$minx,$xbins,$ysize,$miny,$ybins);
my ($max, $xp, $yp)= max2d_ind($h);

my $xsh=$minx+$xp*$xsize;
my $ysh=$miny+$yp*$ysize;

if ($lab ne '') {
#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
# Make a plot

pgbegin(0,"fcorr.ps/PS",1,1);

pgenv(min($a),max($a),min($d),max($d),0,1);

pgsch(0.7);

my $labv=sprintf "\\gD\\ga = %.4f \\gD\\gd= %.4f",$xsh, $ysh;
$lab=$lab.$labv;

pglab('','',$lab);

pgsch(1.2);
pglab('\ga','\gd','');

#pgpoint(nelem($a),$a->get_dataref, $d->get_dataref,3);


pgpoint(nelem($ar),$ar->get_dataref, $dr->get_dataref,2);

#print min($ar), min($dr), max($ar), max($dr), "\n";


 my $x= $a + float($xsh);
 my $y= $d + float($ysh);
 pgpoint(nelem($x),$x->get_dataref, $y->get_dataref,4);

pgpage();

   $x=$c->slice("0:$nc,(0)");
   $y=$c->slice("0:$nc,(1)");
  pgenv($minx,$minx+2*$xl,$miny,$miny+2*$yl,0,1);
  pglab('\gD\ga','\gD\gd','');
  pgpoint(nelem($x),$x->get_dataref, $y->get_dataref,2);

pgend();


#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

}

#return piddles CONVERTED TO SCALAR !!!!!!!!!!!!!!!!!!

return ($xsh->at, $ysh->at, $nc);

}


1;
