#!/usr/local/bin/perl

use strict;
use Carp;
use Getopt::Long;

use Cwd;
#use Tools::mklist;
use Tools::setdata;
use Common::callPck;
use Instr::IConfig;
use Common::misc;


#use FindBin;
use File::Basename;


 #$Getopt::Long::debug=1;

 my %optctl = ();
 &GetOptions (\%optctl, "h","mode|m=s",
 "pack|p=s","step|s=s@","input|i=s@","output|o=s@",
 "apply=s@", "name=s@",
 "admin|adm=s@", "opt=s@",
 "conf|c=s", "gui");


use vars qw/$package $interface $seldir $redmode $work_dir $debug $top $newlog/;

use vars qw /$ParFile $params $_wfile/;




#/////////////////////////

&Init();  #define these variables, the sub is in Common::misc.pm
&LoadPrefs();

#/////////////////////////
# some initializations
$interface='cmd';
$package="PDL";
$seldir="";
$redmode="RUN";
$work_dir=cwd;
$newlog=1;

$_wfile='';    #this will contain the name of a file that is being written, in case of interrupts.

#\\\\\\\\\\\\\\\\\\\\\\\\\

my $ppid=$$; #the PID of the main script
if ($main::DEBUG) {print "#DEBUG main procedure started: PID $ppid \n"};

#system ("echo PID $ppid >> $main::PIPEFILE");

#if (-e $logfile) {system ("rm $logfile")}
#\\\\\\\\\\\\\\\\\\\\\\\\\

# Enable trapping of ctrl-C (from man perlipc)

      sub catch_zap {
          my $signame = shift;
          warn "I (batch.pl) got a CTRL-C: exiting !";           
	  mkLog ("ERROR: procedure stopped !\n");
          if ($redmode ne 'listonly' && $_wfile && -e $_wfile) {
             mkLog ("removing $_wfile !\n");
             system ("rm $_wfile");
          }
	  mkLog ("</PROC>\n");
	  system ("rm $TMPLOGFILE") if (-e $TMPLOGFILE);
	  exit;
	  #return;
      }
      $SIG{INT} = \&catch_zap;  # best strategy

   
if ($optctl{'h'}) {
   print "*** INTERACTIVE MODE ***\n";
   print "prered\n";
    print "*** COMMAND LINE MODE ***\n";
   print "prered \n";
   print "         -step[bias|dark|flat|sflat|fringe|science]\n";
   print "         -i{nput}<list> -o{output}<name>\n";
   print "         -apply[bias|dark|flat|sflat|mkfringe] -name<name>\n";
   print "         -adm{in}[instr|redo|clean] -opt{ion}<cfh12k|esowfi;y|n}\n";
   print "         -m{ode}[t|a]\n";
   print "         -p{ack}[pdl|iraf|flips]\n"; 
   print "         -c{onf}<conf_file>\n";
   print "         -gui           (internal) \n";
    die;
}    

# ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
# check if the GUI should be on or off

if ($optctl{'gui'}) {
    $interface = 'gui';
   # require Tk;
 }

my @steps=@{$optctl{'step'}};

# ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
# $opt_adm: = set option in the administration section

if (defined $optctl{'admin'}) {
   my @admin=@{$optctl{'admin'}};
   my @adm_opt=@{$optctl{'opt'}};
   for my $i (0..$#admin) {
      if ($admin[$i] =~ /inst/i) {
           if ($adm_opt[$i] =~ /cfh12/i) {$INSTRUMENT='CFH12K'}
	   elsif ($adm_opt[$i] =~ /esowfi/i) {$INSTRUMENT='ESOWFI'}
      }
      elsif ($admin[$i] =~ /redo/i) {
         if ($adm_opt[$i] =~ /y/i) {$REDO='yes'} else {$REDO='no'}  
      }
      elsif ($admin[$i] =~ /clean/i) {
         if ($adm_opt[$i] =~ /y/i) {$CLEAN='yes'} else {$CLEAN='no'}  
      }
      
   
   }
   
}


# ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
# $opt_m: the mode (test:RUN:mklists)

$redmode='RUN';

  if ($optctl{'mode'} eq 't' || $optctl{'mode'} eq 'listonly') {$redmode='listonly'}
  elsif ($optctl{'mode'} eq 'l' || $optctl{'mode'} eq 'mklists') {$redmode='mklists'}
#  if ($optctl{'mode'} eq 'a' || $optctl{'mode'} eq 'RUN') {$redmode='RUN'}


# ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
# $opt_p: the package to be used (iraf/pdl/flips)

$package=$optctl{'pack'} if ($optctl{'pack'} ne '');


# ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
# $optctl{"conf"}: the configuration file to be used 

if ($optctl{'conf'} ne '') {
# copying the given file to the default parameter file 
$ParFile=$optctl{'conf'};
#if (-e $CONFIG) {LoadParams("$CONFIG")}   #load the parameters from the co
}

$params=IConfig->new($ParFile);




#^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^  
# Update the configuration file


if ($interface ne 'gui') {
  my $opts="";

  if (defined $optctl{'input'} || defined $optctl{'output'} || defined $optctl{'apply'} ) {

  my $opts="";

  if (defined $optctl{'input'}) {
    $opts=$opts." -field $optctl{'step'}"." -option input"." -value $optctl{'input'} ";
   }

  if (defined $optctl{'output'}) {
          $opts=$opts." -field $optctl{'step'}"." -option output"." -value $optctl{'output'} ";
   }

   if (defined $optctl{'apply'}) {

    if (! defined $optctl{'name'}) {
          die "Error: no -name defined for -apply !!\n"
      }
    my @apply=@{$optctl{'apply'}};
    my @name=@{$optctl{'name'}};

    if ($#name != $#apply) {
      die "Error: arguments in -apply and -name do not match !! \n"
    }

  foreach my $i (0..$#apply ) {
     next if ($apply[$i] eq  $optctl{'step'});
     $opts=$opts." -field $apply[$i]"." -option apply"." -value yes";
     $opts=$opts." -field $apply[$i]"." -option output"." -value $name[$i] ";
    }

   }

  system("perl $BIN/set_config.pl $opts");
}

} #end if NOT gui


$params->LoadParams();

   my $now=&mkdate;


      if (-e "$SFILE") {
        system ("mv $SFILE $SFILE.bck");
      }
    open (SFILE, ">$SFILE");
    print SFILE "Summary file created on: $now\n";
    close (SFILE);

 
    my $t = $ParFile;
    my @s=split(/\./, $ParFile);
    my ($base, $p, $s) = fileparse($ParFile, $s[$#s]);
    $LOGFILE= "$SOFT->{NAME}[1]-$base".'log';
    $TMPLOGFILE="$LOGFILE.tmp.$$";

    system ("rm $LOGFILE") if (-e $LOGFILE);
    system ("rm $TMPLOGFILE") if (-e $TMPLOGFILE);

    mkLog("<PROC>\n");
    mkLog("<$SOFT->{NAME}[0]> $SOFT->{NAME}[1] </$SOFT->{NAME}[0]>\n");
    mkLog("<$SOFT->{VERSION}[0]> $SOFT->{VERSION}[1] </$SOFT->{VERSION}[0]>\n");
    mkLog("<procsoft> $package </procsoft>\n");
    mkLog("<procmode> $redmode </procmode>\n");
    mkLog("<instrument> $params->{general}{instrument}{Value} </instrument>\n");
    mkLog("<rawFITS> $params->{general}{fits_type}{Value} </rawFITS>\n");
    mkLog("<date> $now </date>\n");


    #open (LOGFILE , ">> $LOGFILE");
    #print LOGFILE "<CONFIG>\n";
      
    mkLog("<CONFIGFILE> $ParFile </CONFIGFILE>\n");
   
STEP: foreach my $step (@steps) {

my $ustep=uc($step);

mkLog ("<procstep> $ustep\n");

   if ($REDO eq 'no') {

      my ($i_ncheck, $i_ntot)= $params->checkList($step, 'input') ;
                  
     my ($o_ncheck, $o_ntot)= $params->checkList($step, 'output') ;
     if ($i_ncheck==-1 ||  ($redmode ne 'mklists' && $o_ncheck == $o_ntot) ) {
     my $olist=$params->getList($step, 'output');
        mkLog("Skipping, the list $olist already contains $o_ncheck images",'w');
        mkLog ("</procstep>");
        print "*************************************\n";
        next STEP;
      }
  }

#^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
# $optctl{'step'}: what should be done

if ($step eq "bias") {

    my $ret=0;

    print "*************************************\n";
    print "      Creating a BIAS frame \n";

    $ret=runSoft($package, "bias");
    
    print "*************************************\n";

}

elsif ($step eq "dark") {

    my $ret=0;

    print "*************************************\n";
    print "      Creating a DARK frame \n";

    $ret=runSoft($package, "dark");

    print "*************************************\n";
}

elsif ($step eq "dflat") {

       my $ret=0;

       print "*************************************\n";
       print "      Creating a DOME FLAT frame \n";

       $ret=runSoft($package, "dflat");

       print "*************************************\n";
}

elsif ($step eq "tflat") {

       my $ret=0;

       print "*************************************\n";
       print "      Creating a TWILIGHT FLAT frame \n";

       $ret=runSoft($package, "tflat");

       print "*************************************\n";
}

elsif ($step eq 'fringe') {

       my $ret=0;

        print "*************************************\n";
       print "      Creating a FRINGE frame \n";

       $ret=runSoft($package, "fringe");

       print "*************************************\n";
     }


elsif ($step eq "sflat") {

       my $ret=0;

       print "*************************************\n";
       print "      Creating a SUPERFLAT frame \n";

       $ret=runSoft($package, "sflat");

       print "*************************************\n";
}

 elsif ($step eq 'science') {

       my $ret=0;

        print "*************************************\n";
        print "      Processing SCIENCE frames \n";

       $ret=runSoft($package, "science");

       print "*************************************\n";
     }    
else {
      warn "?????????????????????????????????????";
      warn "   I do not understand: $step     !!";         
      warn "?????????????????????????????????????";
}      

mkLog ("</procstep>");

} #end loop on steps

mkLog('</PROC>');
print "====================================================\n";

      if ($redmode eq "mklists") {
    print "***************************************************************\n";
       print "   SUMMARY   ($SFILE)  \n";
             open (SFILE, "$SFILE");
	     while (<SFILE>) {print "$_"};
	     close (SFILE);
    print "***************************************************************\n";
      }

sleep(2);


sub mkLog
{
my ($msg, $lev, $task)=@_;


my $l='';

if ($lev =~ /w/i) {$l= "Warning - $task: "}
elsif ($lev =~ /e/i) {$l="ERROR - $task: "}


my @smsg=split('\n', $msg);
$smsg[0]=$l.$smsg[0];


my $imsg;

open ERRLOG, ">>$LOGFILE";

#if ($interface eq 'gui') {
#   open TMPLOG, ">>$TMPLOGFILE";
#}

foreach $imsg (@smsg) {  
 print "$imsg\n";
 print ERRLOG "$imsg\n";
 if ($DEBUG) {carp "$imsg\n"}
}

close (ERRLOG);

#if ($interface eq 'gui') {
#   close (TMPLOG);
#   dispLog();
#}

  
#if ($lev =~ /e/i) {die}

} #end sub mkLog

sub SumList
  {

my ($list, $what, $step, $procfiles, $dfiles)=@_;

  open (SFILE, ">>$SFILE");
    print SFILE "$step/$what: <$list> contains $procfiles files, $dfiles exist\n";  
  close (SFILE);

  }
