#bench1 : threading on a transposed PDL
# a) Transpose PDL, make operation and transpose back                              17s    
# b) Create a child PDl, transpose it and make the (backword assigned) operation   17s
# c) Create a child PDl, transpose it and make the (backword assigned) operation
#    using an inplace operator                                                     13s


use PDL;
 use Benchmark;

$a=float[[1,2,3],[3,4,5]];
$b=float[[-1,240,330],[3,490,50]];

$stack=zeroes(float,3,2,2);

($tmp=$stack->slice(':,:,0')) .= $a;
($tmp=$stack->slice(':,:,1')) .= $b;

$scalf=zeroes(float,2);

set ($scalf,0,avg($a));
set ($scalf,1,avg($b));

$mmed= average($scalf) ;
print $mmed;
print $scalf;

$count=10000;

$t=timeit($count, '$s=$stack->copy;$s=($s->mv(2,0)/$scalf*$mmed)->mv(0,2)');
  print "\n$count loops of (a) code took:",timestr($t),"\n";
  print "$scalf\n";
print "$mmed \n";
print "$s\n";


$t=timeit($count, '$s=$stack->copy;my $tmp;$tmp=$s->mv(2,0); $tmp .= $tmp/($scalf/$mmed)');


  print "$count loops of (b) code took:",timestr($t),"\n";
 print "$scalf\n";
print "$mmed \n";



$t=timeit($count, '$s=$stack->copy;my $tmp;$tmp=$s->mv(2,0); $tmp /= ($scalf/$mmed)');


  print "$count loops of (c) code took:",timestr($t),"\n";
 print "$scalf\n";
print "$mmed \n";
print "$s\n";
print "$s\n";
