#!/usr/local/bin/perl

use strict;
use Getopt::Long;
use Tie::IxHash;

use Common::misc; 
 
 my %optctl = ();
 &GetOptions (\%optctl, "h","field|f=s@", "option|o=s@", "value|v=s@", "conf|c=s");

if ($optctl{'h'}) {
 print "set_config \n";
 print "         -field[bias|dark|flat|sflat|mkfringe] -option[xxx] -value[xxx]\n";
 die;
}


&defParams();

#read the existing configuration file

my $cfile='batch.par';
if (defined  $optctl{'conf'}) {$cfile= $optctl{'conf'}}

if (-e $cfile) {
   LoadParams($cfile);
}

# update the given parameters, if mode=write

#my $mode='w';
#if (defined $optctl{'mode'} ) {$mode= $optctl{'mode'} }
#$mode=lc($mode);

#if ($mode eq 'w') {
 if (defined $optctl{'field'} ) {
  my @field=@{$optctl{'field'}};
  
  foreach my $i (0..$#field ) {
     my $field=$field[$i];
     my $option=$optctl{'option'}[$i];
     my $value=$optctl{'value'}[$i];
     
     $params{$field}{$option}{Value}=$value; 

 }

}

SaveParams($cfile);
